//+------------------------------------------------------------------+
//|                                                        COTI1.mq4 |
//|                                                 Kamil Gazizullin |
//|                                             forexman77@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Kamil Gazizullin"
#property link      "forexman77@yandex.ru"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
//--- input parameters
extern int p=150;
extern string    File_Name    ="COT\\COTJPY.csv";
//--- buffers
double ExtMapBuffer1[];
double P[];
double Plus[];
double Minus[];
double index[];
double TIME[];
double SOLAR[];
int shetchik;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int Handle,Skip;
   double kol_vo;
   string Text,Str_DtTm;
   datetime Dat_DtTm;
   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,";");//  
   if(Handle<0) // Failure when opening a file
     {
      if(GetLastError()==4103)
         Alert("There is no file named ",File_Name);
      else
         Alert("Error when opening a file ",File_Name);
      PlaySound("Bzrrr.wav");
      return(0);
     }
   while(FileIsEnding(Handle)==false)
   {
   Skip =FileReadString(Handle);//
   if(FileIsLineEnding(Handle))shetchik=shetchik+1;
   if(FileIsEnding(Handle)){FileClose(Handle);}// -     
   }
   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,";");//  
   if(Handle<0) // Failure when opening a file
     {
      if(GetLastError()==4103)
         Alert("There is no file named ",File_Name);
      else
         Alert("Error when opening a file ",File_Name);
      PlaySound("Bzrrr.wav");
      return(0);
     }
   ArrayInitialize(TIME,0);
   ArrayInitialize(SOLAR,0);
   for(int k=shetchik;k>=0;k--)
     {
         //--------------------------------------------------------- 5 --
         Str_DtTm =FileReadString(Handle);//  
         Text     =FileReadString(Handle);//  
         //--------------------------------------------------------- 6 --
         Dat_DtTm=StrToTime(Str_DtTm);   //    
         kol_vo=StringToDouble(Text);   //     
         ArrayResize(TIME,shetchik);
         ArrayResize(SOLAR,shetchik);
         TIME[k]=Dat_DtTm;
         SOLAR[k]=kol_vo;
         //--------------------------------------------------------- 7 --
         if(FileIsEnding(Handle)==true){ Print(" =",TimeToString(Dat_DtTm));break;}// 

     }
FileClose(Handle);
//---- indicators
   IndicatorBuffers(7);
   SetIndexBuffer(0,index);
   SetIndexBuffer(1,Plus);
   SetIndexBuffer(2,Minus);
   SetIndexBuffer(3,P);
   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer(4,ExtMapBuffer1);
   IndicatorDigits(Digits+1);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(),limit,r;
   double max,min,COT1,COT2;

   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars-1;

   for(int i=limit;i>=0;i--)
   {
   r=Time[i]+604800;
     for (int t=i+15;t>=0;t--)
     {
     if(TIME[t]>=Time[i]&&TIME[t]<=r)
     {
     ExtMapBuffer1[i]=SOLAR[t];
     break;
     }
     }
   }
  for(i=limit;i>=0;i--)
  {
  if (ExtMapBuffer1[i]!=0.0)P[i]=ExtMapBuffer1[i];
  if (ExtMapBuffer1[i]==0.0)P[i]=ExtMapBuffer1[i+1];  
  }
  for(i=limit;i>=0;i--)
  {
  min=P[ArrayMinimum(P,p,i)];
  max=P[ArrayMaximum(P,p,i)];
  Minus[i]=min;
  Plus[i]=max;
  }
  for(i=limit;i>=0;i--)
  {
  COT1=P[i]-Minus[i];
  COT2=Plus[i]-Minus[i];
  if (COT2!=0)index[i]=(COT1/COT2)*100.0;
  
  }
   return(0);
  }
//+------------------------------------------------------------------+
